* Module:	INPUT110.PRG
* Version:	Beta 1.0
* Purpose:	Enter SOTER units in database file terrain.dbf

* Called by:	INPUT100.PRG
* Calling:	Procedure i_suid in INPUT110.PRG
*               Format file INPUT110.FMT

* Date:		15 April 1993
* Author:	P. Tempel
* Updates:	1 July 1993		by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) terrain variables
   STORE 0 TO tmp_suid, tmp_date, tmp_mnel, tmp_mxel, tmp_slop,  ;
              tmp_reli, tmp_hyps, tmp_wate
   STORE SPACE(1) TO tmp_diss
   STORE SPACE(2) TO tmp_lndf, tmp_rslo
   STORE SPACE(3) TO tmp_lith
   STORE SPACE(12) TO tmp_mapi

   STORE "L, LP, LL, LD, LF, LV, S, SM, SH, SE, SR, SU, SP, T, "+  ;
         "TM, TH, TE, TV, C, CV, CD, CL" TO tmp_lflist
   STORE "W, F, G, U, R, S, T, V, CU, DO, RI, TE, IN, DU, IN, WE, KA"  ;
         TO tmp_rslist


   * Enter a valid primary key
   DO i_suid
   IF tmp_suid = 0    && IN CASE OF ZERO KEY VALUE
      EXIT            && RETURN TO CALLING PROGRAM
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   * Open database file with source map data
   CLOSE DATABASES
   USE sourcmap ORDER pk


   DO WHILE .T.

      SET ESCAPE ON
      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      ON KEY LABEL F1 DO helpinfo
      SET FORMAT TO input110
      READ

      ON KEY LABEL F1
      CLOSE DATABASES
      SET ESCAPE OFF

      * Process ESC
      IF READKEY() = 12			&& ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE terrain ORDER pk
            APPEND BLANK
            REPLACE suid WITH tmp_suid
            REPLACE date WITH tmp_date
            REPLACE mapi WITH tmp_mapi
            REPLACE mnel WITH tmp_mnel
            REPLACE mxel WITH tmp_mxel
            REPLACE slop WITH tmp_slop
            REPLACE reli WITH tmp_reli
            REPLACE lndf WITH tmp_lndf
            REPLACE rslo WITH tmp_rslo
            REPLACE hyps WITH tmp_hyps
            REPLACE diss WITH tmp_diss
            REPLACE lith WITH tmp_lith
            REPLACE wate WITH tmp_wate
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_suid
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_suid FROM 17, 25 TO 21, 70
ACTIVATE WINDOW i_suid
DO WHILE .T.

   STORE 0 TO tmp_suid
   CLEAR
   @ 01, 07 SAY "1  SOTER unit_ID      " GET tmp_suid PICTURE "@Z 9999" ;
       MESSAGE "Enter a four-digit SOTER unit_ID"
   READ

   IF tmp_suid = 0
      DEACTIVATE WINDOW i_suid
      RELEASE WINDOW i_suid
      RETURN
   ENDIF

   USE terrain ORDER pk		&& START SUID CHECK
   IF SEEK(tmp_suid)
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY " ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(STR(tmp_suid))+" is not a unique SOTER unit_ID."
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF			&& END SUID CHECK

ENDDO

DEACTIVATE WINDOW i_suid
RELEASE WINDOW i_suid
SET BORDER TO DOUBLE
RETURN


FUNCTION lith_code
******************
PARAMETERS lith
length = LEN(LTRIM(TRIM(lith)))

DO CASE

   CASE length = 3
      class = SUBSTR(LTRIM(TRIM(lith)), 1, 1)
      group = SUBSTR(LTRIM(TRIM(lith)), 2, 1)
      typenr  = SUBSTR(LTRIM(TRIM(lith)), 3, 1)
      IF .NOT. (typenr $ "1234")
         RETURN .F.
      ENDIF
      DO CASE
         CASE class = "I"
            DO CASE
               CASE group $ "BU" .AND. (typenr $ "123")
                  RETURN .T.
               CASE group = "I" .AND. (typenr $ "12")
                  RETURN .T.
               CASE group = "A" .AND. (typenr $ "1234")
                  RETURN .T.
            ENDCASE 
         CASE class = "M"
            DO CASE
               CASE group = "A" .AND. (typenr $ "12")
                  RETURN .T.
               CASE group = "B" .AND. (typenr $ "1234")
                  RETURN .T.
            ENDCASE
         CASE class = "S"
            DO CASE
               CASE group = "E" .AND. (typenr $ "12")
                  RETURN .T.
               CASE group = "O" .AND. (typenr $ "123")
                  RETURN .T.
               CASE group = "C" .AND. (typenr $ "1234")
                  RETURN .T.
            ENDCASE
      ENDCASE

   CASE length = 2
      class = SUBSTR(LTRIM(TRIM(lith)), 1, 1)
      group = SUBSTR(LTRIM(TRIM(lith)), 2, 1)
      DO CASE 
         CASE class = "I"
            IF group $ "AIBU"
               RETURN .T.
            ENDIF
         CASE class = "M"
            IF group $ "AB"
               RETURN .T.
            ENDIF
         CASE class = "S"
            IF group $ "COE"
               RETURN .T.
            ENDIF
         CASE class = "U"
            IF group $ "FLMCEGPO"
               RETURN .T.
            ENDIF
      ENDCASE

   CASE length = 1
      IF LTRIM(TRIM(lith)) $ "IMSU"
         RETURN .T.
      ENDIF

ENDCASE

RETURN .F.
