* Module:	INPUT120.PRG
* Version:      Beta 1.0
* Purpose:      Enter terrain components in database file terrcomp.dbf

* Called by:    INPUT100.PRG
* Calling:      procedure i_tckey in INPUT120.PRG

* Date:         15 April 1993
* Author:       P. Tempel
* Updates:      15 April 1993         by P. Tempel
* * * * * * * * * * * * * * *

DO WHILE .T.

   * Declaration of (temporary) terrain component variables
   STORE 0 TO tmp_suid, tmp_tcid, tmp_prop
   STORE SPACE(6) TO tmp_tcdc


   * Enter a valid primary key
   DO i_tckey
   IF tmp_suid = 0 .OR. tmp_tcid = 0   && IN CASE OF ZERO KEY VALUES
      EXIT                             && RETURN TO CALLING PROGRAM
   ENDIF


   * Declaration of (temporary) Terrain component data code variables
   STORE tmp_suid TO tmp_tcdc1
   STORE tmp_tcid TO tmp_tcdc2


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input120
      READ

      * Process ESC
      IF READKEY() = 12               && ESC:
         STORE .N. TO tmp_answ        && RETURN TO CALLING PROGRAM
         EXIT                         && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE terrcomp ORDER pk
            APPEND BLANK
            REPLACE suid WITH tmp_suid
            REPLACE tcid WITH tmp_tcid
            REPLACE prop WITH tmp_prop
            STORE LTRIM(TRIM(STR(tmp_tcdc1)))+"/"+LTRIM(TRIM(STR(tmp_tcdc2))) ;
                           TO tmp_tcdc
            REPLACE tcdc WITH tmp_tcdc
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ
         
         SET CONFIRM ON
         SET ESCAPE ON
         EXIT
            
      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
  ENDIF

ENDDO
RELEASE ALL LIKE tmp*
SET BORDER TO DOUBLE
SET FORMAT TO
DEACTIVATE WINDOW f_screen
RETURN




PROCEDURE i_tckey
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_tckey FROM 16, 15 TO 21, 68
ACTIVATE WINDOW i_tckey
DO WHILE .T.

   STORE 0 TO tmp_suid, tmp_tcid
   CLEAR

   * Enter Terrain component primary key values
   DO WHILE .T.
      @ 01, 05 SAY "14  SOTER unit ID" 
      @ 01, 40 GET tmp_suid PICTURE "@Z 9999" ;
            MESSAGE "Enter a four-digit SOTER unit ID"
      @ 02, 05 SAY "15  Terrain Component number"
      @ 02, 43 GET tmp_tcid PICTURE "@Z 9" ;
            MESSAGE "Enter a one-digit terrain component number"
      READ
      IF READKEY() = 15 .OR. READKEY() = 271
         EXIT
      ENDIF
   ENDDO

   * Return if one of the primary kay values is 0 (zero)
   IF tmp_suid = 0 .OR. tmp_tcid = 0
      DEACTIVATE WINDOW i_tckey
      RETURN
   ENDIF

   * Check existence of the SOTER unit_ID
   USE terrain ORDER pk
   IF .NOT. SEEK(tmp_suid)	&& SUID NOT FOUND
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 02, 01 SAY LTRIM(STR(tmp_suid))+" not an existing SOTER unit ID"
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check for existence of Terrain component
   STORE LTRIM(TRIM(STR(tmp_suid)))+LTRIM(TRIM(STR(tmp_tcid))) TO tmp_tcdc
   USE terrcomp ORDER k1
   IF SEEK(tmp_tcdc)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY "Terrain component number "+LTRIM(STR(tmp_tcid))+ ;
                   " is not unique within"
      @ 02, 01 SAY "SOTER unit with ID "+LTRIM(STR(tmp_suid))
      WAIT " Press any key to continue..."
   ELSE
      USE
      STORE LTRIM(TRIM(STR(tmp_suid)))+"/"+LTRIM(TRIM(STR(tmp_tcid)))  ;
         TO tmp_tcdc
      EXIT
   ENDIF			&& END SUID CHECK

ENDDO
DEACTIVATE WINDOW i_tckey
RELEASE WINDOW i_tckey
SET BORDER TO DOUBLE
RETURN


FUNCTION chk_tcdc1
******************
PARAMETERS tmp_sotid
USE terrain ORDER pk
is_there = SEEK(tmp_sotid)
USE
RETURN is_there
