DO WHILE .T.

   * Declaration of (temporary) terrain component data variables
   STORE 0 TO tmp_scgr, tmp_scdl, tmp_mrah, tmp_suid, tmp_tcid,     ;
              tmp_mrpr, tmp_bedr, tmp_gwat, tmp_fldu,               ;
              tmp_flst1, tmp_flst2, tmp_flst3
   STORE SPACE(1) TO tmp_scfm, tmp_mrsf, tmp_text, tmp_drai, tmp_flfr
   STORE SPACE(3) TO tmp_lith
   STORE SPACE(6) TO tmp_tcdc, tmp_flst

   *Enter a valid primary key
   DO i_tcdc
   IF tmp_suid = 0 .OR. tmp_tcid = 0 
      EXIT
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input130
      READ

      * Process ESC
      IF READKEY() = 12    		&& ESC:
         STORE .N. TO tmp_answ		&& Return to calling program
         EXIT
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271      && <Enter>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE tcdata ORDER pk
            APPEND BLANK
            REPLACE tcdc WITH tmp_tcdc
            REPLACE scgr WITH tmp_scgr
            REPLACE scdl WITH tmp_scdl
            REPLACE scfm WITH tmp_scfm
            REPLACE mrsf WITH tmp_mrsf
            REPLACE mrah WITH tmp_mrah
            REPLACE mrpr WITH tmp_mrpr
            REPLACE lith WITH tmp_lith
            REPLACE text WITH tmp_text
            REPLACE bedr WITH tmp_bedr
            REPLACE drai WITH tmp_drai
            REPLACE gwat WITH tmp_gwat
            REPLACE flfr WITH tmp_flfr
            REPLACE fldu WITH tmp_fldu

            IF LEN(LTRIM(STR(tmp_flst1))) = 1
               STORE "0"+LTRIM(STR(tmp_flst1)) TO tmp_flst1
            ELSE 
               STORE LTRIM(STR(tmp_flst1)) TO tmp_flst1
            ENDIF
            IF LEN(LTRIM(STR(tmp_flst2))) = 1            
               STORE "0"+LTRIM(STR(tmp_flst2)) TO tmp_flst2
            ELSE
               STORE LTRIM(STR(tmp_flst2)) TO tmp_flst2
            ENDIF
            IF LEN(LTRIM(STR(tmp_flst3))) = 1
               STORE "0"+LTRIM(STR(tmp_flst3)) TO tmp_flst3
            ELSE
               STORE LTRIM(STR(tmp_flst3)) TO tmp_flst3
            ENDIF

            STORE tmp_flst1+tmp_flst2+tmp_flst3 TO tmp_flst

            REPLACE flst WITH tmp_flst
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET TMP_ANSW PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO
   

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && Insert another record
      LOOP                         && Start at beginning of DO WHILE loop
   ELSE
      EXIT                         && Return to calling program
   ENDIF

ENDDO
RELEASE ALL LIKE TMP*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
SET CONFIRM ON
RETURN



PROCEDURE i_tcdc
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_tcdc FROM 17, 14 TO 21, 70
ACTIVATE WINDOW i_tcdc
DO WHILE .T.

   STORE 0 TO tmp_suid, tmp_tcid
   CLEAR


   * Read terrain component data code
   DO WHILE .T.
      @ 01, 01 SAY "Enter Terrain component data code: " 
      @ 01, 36 GET tmp_suid PICTURE "@Z 9999" ;
            MESSAGE "Enter SOTER unit_ID"
      @ 01, 41 SAY "/"
      @ 01, 43 GET tmp_tcid PICTURE "@Z 9" ;
            MESSAGE "Enter Terrain component number"
      READ
      IF READKEY() = 15 .OR. READKEY() = 271
         EXIT
      ENDIF
   ENDDO


   * Return if one of the ID's is 0 (zero)
   IF tmp_suid = 0 .OR. tmp_tcid = 0
      DEACTIVATE WINDOW i_tcdc
      RETURN
   ENDIF


   * Check existence of SOTER unit in database file "terrain"
   USE terrain ORDER pk
   IF .NOT. SEEK(tmp_suid)	&& SUID not found
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(STR(tmp_suid))+" not an existing SOTER unit"
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Create terrain component data code from the SOTER unit_ID and
   * the terrain component number.
   STORE LTRIM(STR(tmp_suid))+"/"+LTRIM(STR(tmp_tcid)) TO tmp_tcdc


   USE terrcomp ORDER fk1
   IF .NOT. SEEK(tmp_tcdc)
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY "No cross link for terrain component data code "+tmp_tcdc
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF



   USE tcdata ORDER pk		&& START SUID CHECK
   IF SEEK(tmp_tcdc)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(tmp_tcdc)+" not a unique Terrain component data code"
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF			&& END SUID CHECK

ENDDO
DEACTIVATE WINDOW i_tcdc
RELEASE WINDOW i_tcdc
SET BORDER TO DOUBLE
RETURN


FUNCTION lith_code
******************
PARAMETERS lith
length = LEN(LTRIM(TRIM(lith)))

DO CASE

   CASE length = 3
      class = SUBSTR(LTRIM(TRIM(lith)), 1, 1)
      group = SUBSTR(LTRIM(TRIM(lith)), 2, 1)
      typenr  = SUBSTR(LTRIM(TRIM(lith)), 3, 1)
      IF .NOT. (typenr $ "1234")
         RETURN .F.
      ENDIF
      DO CASE
         CASE class = "I"
            DO CASE
               CASE group $ "BU" .AND. (typenr $ "123")
                  RETURN .T.
               CASE group = "I" .AND. (typenr $ "12")
                  RETURN .T.
               CASE group = "A" .AND. (typenr $ "1234")
                  RETURN .T.
            ENDCASE 
         CASE class = "M"
            DO CASE
               CASE group = "A" .AND. (typenr $ "12")
                  RETURN .T.
               CASE group = "B" .AND. (typenr $ "1234")
                  RETURN .T.
            ENDCASE
         CASE class = "S"
            DO CASE
               CASE group = "E" .AND. (typenr $ "12")
                  RETURN .T.
               CASE group = "O" .AND. (typenr $ "123")
                  RETURN .T.
               CASE group = "C" .AND. (typenr $ "1234")
                  RETURN .T.
            ENDCASE
      ENDCASE

   CASE length = 2
      class = SUBSTR(LTRIM(TRIM(lith)), 1, 1)
      group = SUBSTR(LTRIM(TRIM(lith)), 2, 1)
      DO CASE 
         CASE class = "I"
            IF group $ "AIBU"
               RETURN .T.
            ENDIF
         CASE class = "M"
            IF group $ "AB"
               RETURN .T.
            ENDIF
         CASE class = "S"
            IF group $ "COE"
               RETURN .T.
            ENDIF
         CASE class = "U"
            IF group $ "FLMCEGPO"
               RETURN .T.
            ENDIF
      ENDCASE

   CASE length = 1
      IF LTRIM(TRIM(lith)) $ "IMSU"
         RETURN .T.
      ENDIF

ENDCASE

RETURN .F.
