* Module:       INPUT140.PRG
* Version:      Beta 1.0
* Purpose:      Enter soil component data in database file soilcomp.dbf

* Called by:    INPUT140.PRG
* Calling:      procedure i_sckey in INPUT140.PRG

* Date:         27 June 1993
* Author:       P. Tempel
* Updates:      27 June 1993         by P. Tempel
* * * * * * * * * * * * * * *

DO WHILE .T.

   * Declaration of (temporary) soil component variables
   STORE 0 TO tmp_suid, tmp_tcid, tmp_scid, tmp_prop, tmp_nrpr, tmp_eraa
   STORE .F.        TO tmp_rela
   STORE SPACE(1)   TO tmp_posi, tmp_rksc, tmp_stsc, tmp_erty, tmp_erde, ;
                       tmp_scap, tmp_rdep
   STORE SPACE(12)  TO tmp_prid
   STORE SPACE(254) TO tmp_scrm


   * Enter a valid primary key
   DO i_sckey
   DO CASE
      CASE tmp_suid = 0 
         EXIT
      CASE tmp_tcid = 0
         EXIT
      CASE tmp_scid = 0
         EXIT
   ENDCASE


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   CLOSE DATABASES
   USE isocode ORDER pk
   USE profile ORDER pk IN SELECT()


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input140
      READ

      * Process ESC
      IF READKEY() = 12               && ESC:
         STORE .N. TO tmp_answ        && RETURN TO CALLING PROGRAM
         EXIT                         && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE soilcomp ORDER pk
            APPEND BLANK
            REPLACE suid WITH tmp_suid
            REPLACE tcid WITH tmp_tcid
            REPLACE scid WITH tmp_scid
            REPLACE prop WITH tmp_prop
            REPLACE prid WITH tmp_prid
            REPLACE nrpr WITH tmp_nrpr
            REPLACE posi WITH tmp_posi
            REPLACE rksc WITH tmp_rksc
            REPLACE stsc WITH tmp_stsc
            REPLACE erty WITH tmp_erty
            REPLACE eraa WITH tmp_eraa
            REPLACE erde WITH tmp_erde
            REPLACE scap WITH tmp_scap
            REPLACE rdep WITH tmp_rdep
            REPLACE rela WITH tmp_rela
            USE
            IF tmp_rela
               USE screla ORDER pk
               APPEND BLANK
               REPLACE suid WITH tmp_suid
               REPLACE tcid WITH tmp_tcid
               REPLACE scid WITH tmp_scid
               REPLACE rela WITH tmp_scrm
               USE
            ENDIF
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ
         
         SET CONFIRM ON
         SET ESCAPE ON
         EXIT
            
      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
  ENDIF

ENDDO
CLOSE DATABASES
RELEASE ALL LIKE tmp*
SET BORDER TO DOUBLE
SET FORMAT TO
DEACTIVATE WINDOW f_screen
RETURN




PROCEDURE i_sckey
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_sckey FROM 15, 22 TO 21, 70
ACTIVATE WINDOW i_sckey
DO WHILE .T.

   STORE 0 TO tmp_suid, tmp_tcid, tmp_scid
   CLEAR

   * Enter Soil component primary key values
   DO WHILE .T.
      @ 01, 07 SAY "1  SOTER unit_ID" 
      @ 01, 40 GET tmp_suid  PICTURE "9999" ;
            MESSAGE "Enter a four-digit SOTER unit_ID"
      @ 02, 07 SAY "2  Terrain component number"
      @ 02, 43 GET tmp_tcid  PICTURE "9"  ;
            MESSAGE "Enter Terrain component number (1-9)"
      @ 03, 07 SAY "3  Soil component number"
      @ 03, 43 GET tmp_scid  PICTURE "9" ;
            MESSAGE "Enter Soil component number (1-9)"
      READ

      IF READKEY() = 15 .OR. READKEY() = 271
         EXIT
      ENDIF

   ENDDO


   * Return if one of the primary key values is 0 (zero)
   DO CASE
      CASE tmp_suid = 0 
         DEACTIVATE WINDOW i_sckey
         RELEASE WINDOW i_sckey
         RETURN
      CASE tmp_tcid = 0
         DEACTIVATE WINDOW i_sckey
         RELEASE WINDOW i_sckey
         RETURN
      CASE tmp_scid = 0
         DEACTIVATE WINDOW i_sckey
         RELEASE WINDOW i_sckey
         RETURN
   ENDCASE


   * Check existence of the SOTER unit_ID
   USE terrain ORDER pk
   IF .NOT. SEEK(tmp_suid)    && SUID NOT FOUND
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 02, 01 SAY LTRIM(STR(tmp_suid))+" not an existing SOTER unit"
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check existence of Terrain component
   USE terrcomp ORDER pk
   IF .NOT. SEEK(tmp_suid+tmp_tcid)          && TERRAIN COMPONENT NOT FOUND
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 02, 01 SAY LTRIM(TRIM(STR(tmp_suid)))+"/"+LTRIM(TRIM(STR(tmp_tcid)))+ ;
               " not an existing terrain component"
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check values for primary key of database file soilcomp.dbf
   USE soilcomp ORDER pk
   IF SEEK(tmp_suid+tmp_tcid+tmp_scid)
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY "SOTER unit ID "+LTRIM(STR(tmp_suid))+           ;
                   ", terrain component "+LTRIM(TRIM(STR(tmp_tcid)))
      @ 02, 01 SAY "and soil component "+LTRIM(TRIM(STR(tmp_scid)))+;
                      " do not yield a unique"
      @ 03, 01 SAY "primary key for the soilcomp database file"
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF

   EXIT   && Leave DO WHILE loop after checking key vlues

ENDDO
DEACTIVATE WINDOW i_sckey
RELEASE WINDOW i_sckey
SET BORDER TO DOUBLE
RETURN
