* Module:   	INPUT200.PRG
* Version:  	Beta 1.0
* Purpose:  	Enter profile data in database file profile.dbf

* Called by:	INPUT000.PRG
* Calling:	Procedure i_prid in INPUT200.PRG

* Date:     	22 April 1993
* Author:   	P. Tempel
* Updates:  	30 June 1993           by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) profile variables
   STORE 0 TO tmp_lati, tmp_long, tmp_elev
   STORE SPACE(1)  TO tmp_drai, tmp_infr, tmp_orga
   STORE SPACE(2)  TO tmp_phas
   STORE SPACE(3)  TO tmp_claf
   STORE SPACE(4)  TO tmp_clav
   STORE SPACE(5)  TO tmp_labo, tmp_pdid
   STORE SPACE(7)  TO tmp_date
   STORE SPACE(12) TO tmp_prid, tmp_stax
   STORE SPACE(30) TO tmp_clan


   * Enter a valid primary key
   DO i_prid
   IF "" = LTRIM(TRIM(tmp_prid))          && IN CASE OF ZERO KEY VALUE
      EXIT                                && RETURN TO CALLING PROGRAM
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   * Open database files with ISO country codes, and the 1974 and 1988 
   * soil unit codes
   CLOSE DATABASES
   USE isocode ORDER pk
   USE phase ORDER pk IN SELECT()
   USE fao_74 ORDER pk IN SELECT()
   USE fao_88 ORDER pk IN SELECT()
   USE labname ORDER pk IN SELECT()
   USE profildb ORDER pk IN SELECT()


   DO WHILE .T.

      SET ESCAPE ON
      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      ON KEY LABEL F1 DO helpinfo
      SET FORMAT TO input200
      READ

      ON KEY LABEL F1
      CLOSE DATABASES
      SET ESCAPE OFF

      * Process ESC
      IF READKEY() = 12                 && ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE profile ORDER pk
            APPEND BLANK
            REPLACE PRID WITH tmp_prid
            REPLACE PDID WITH tmp_pdid
            REPLACE LATI WITH tmp_lati
            REPLACE LONG WITH tmp_long
            REPLACE ELEV WITH tmp_elev
            REPLACE DATE WITH VAL(tmp_date)
            REPLACE LABO WITH tmp_labo
            REPLACE DRAI WITH tmp_drai
            REPLACE INFR WITH tmp_infr
            REPLACE ORGA WITH tmp_orga
            REPLACE CLAF WITH tmp_claf
            REPLACE CLAV WITH VAL(tmp_clav)
            REPLACE CLAN WITH tmp_clan
            REPLACE STAX WITH tmp_stax
            REPLACE PHAS WITH tmp_phas
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLOSE DATABASES
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_prid
*****************
SET BORDER TO SINGLE
DEFINE WINDOW i_prid FROM 12, 25 TO 16, 70
ACTIVATE WINDOW i_prid
DO WHILE .T.

   STORE SPACE(12) TO tmp_prid
   CLEAR
   @ 01, 06 SAY "48  Profile_ID     " GET tmp_prid PICTURE "!!XXXXXXXXXX" ;
     MESSAGE "Enter profile_ID, starting with an ISO country code"
   READ

   IF "" = LTRIM(TRIM(tmp_prid))
      DEACTIVATE WINDOW i_prid
      RELEASE WINDOW i_prid
      RETURN
   ENDIF


   * Check Representative profile_ID for valid ISO country code
   USE isocode ORDER pk
   IF .NOT. SEEK(SUBSTR(tmp_prid, 1, 2))
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY " ERROR:" COLOR GR+/R
      @ 00, 09 SAY "First two characters of profile_ID"
      @ 01, 01 SAY "are not a valid ISO country code."
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF

   * Check primary key
   USE profile ORDER pk             && START PROFILE_ID CHECK
   IF SEEK (LTRIM(TRIM(tmp_prid)))
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY " ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(TRIM(tmp_prid))+" is not a unique profile_ID."
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PROFILE_ID CHECK

ENDDO

DEACTIVATE WINDOW i_prid
RELEASE WINDOW i_prid
SET BORDER TO DOUBLE
RETURN



FUNCTION s_date
***************
PARAMETERS date
month = VAL(SUBSTR(date, 1, 2))
IF month < 1 .OR. month > 12
   RETURN .F.
ENDIF
year = VAL(SUBSTR(date, 3, 4))
IF year < 1950 .OR. year > YEAR(DATE())
   RETURN .F.
ENDIF
RETURN .T.
