* Module:	INPUT320.PRG
* Version:      Beta 1.0
* Purpose:      Enter HORIZON minimum values in database file minhoriz.dbf

* Called by:    INPUT300.PRG
* Calling:      procedure i_mphkey in INPUT320.PRG

* Date:         28 June 1993
* Author:       P. Tempel
* Updates:      29 June 1993         by P. Tempel
* * * * * * * * * * * * * * *

DO WHILE .T.

   * Declaration of (temporary) minimum values profile horizon variables
   STORE 0 TO tmp_honu, tmp_sdvc, tmp_sdco, tmp_sdme, tmp_sdfi,     ;
              tmp_sdvf, tmp_sdto, tmp_stpc, tmp_clpc, tmp_bulk,     ;
              tmp_hydc, tmp_infr
   STORE 0 TO tmp_phaq, tmp_phkc, tmp_elco, tmp_exca, tmp_exmg,     ;
              tmp_exna, tmp_exck, tmp_exal, tmp_exac, tmp_cecs
   STORE 0 TO tmp_tceq, tmp_gyps, tmp_totc, tmp_totn, tmp_p2o5,     ;
              tmp_pret, tmp_fede, tmp_fepe, tmp_alde, tmp_alpe
   STORE 0 TO tmp_mc1, tmp_mc2, tmp_mc3, tmp_mc4, tmp_mc5, tmp_t2,  ;
              tmp_t3,  tmp_t4
   STORE SPACE(1) TO  tmp_mina, tmp_mins
   STORE SPACE(4) TO  tmp_pscl
   STORE SPACE(12) TO tmp_prid


   STORE "    , S, LS, SL, SIL, SI, L, SCL, CL, SICL, SC, SIC, C" ;
         TO tmp_pslist

   * Enter a valid primary key
   DO i_mphkey
   IF LTRIM(TRIM(tmp_prid)) = "" .OR. tmp_honu = 0  && IN CASE OF ZERO KEY VALUES
      EXIT                                          && RETURN TO CALLING PROGRAM
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET ESCAPE ON
      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input320
      READ

      * Process ESC
      IF READKEY() = 12               && ESC:
         SET ESCAPE OFF
         STORE .N. TO tmp_answ        && RETURN TO CALLING PROGRAM
         EXIT                         && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE minhoriz ORDER pk
            APPEND BLANK
            REPLACE prid WITH tmp_prid
            REPLACE honu WITH tmp_honu
            REPLACE mina WITH tmp_mina
            REPLACE mins WITH tmp_mins
            REPLACE sdvc WITH tmp_sdvc
            REPLACE sdco WITH tmp_sdco
            REPLACE sdme WITH tmp_sdme
            REPLACE sdfi WITH tmp_sdfi
            REPLACE sdvf WITH tmp_sdvf
            REPLACE sdto WITH tmp_sdto
            REPLACE stpc WITH tmp_stpc
            REPLACE clpc WITH tmp_clpc
            REPLACE pscl WITH tmp_pscl
            REPLACE bulk WITH tmp_bulk
            REPLACE mct1 WITH tmp_mc1
            REPLACE ten2 WITH tmp_t2
            REPLACE mct2 WITH tmp_mc2
            REPLACE ten3 WITH tmp_t3
            REPLACE mct3 WITH tmp_mc3
            REPLACE ten4 WITH tmp_t4
            REPLACE mct4 WITH tmp_mc4
            REPLACE mct5 WITH tmp_mc5
            REPLACE hydc WITH tmp_hydc
            REPLACE infr WITH tmp_infr
            REPLACE phaq WITH tmp_phaq
            REPLACE phkc WITH tmp_phkc
            REPLACE elco WITH tmp_elco
            REPLACE exca WITH tmp_exca
            REPLACE exmg WITH tmp_exmg
            REPLACE exna WITH tmp_exna
            REPLACE exck WITH tmp_exck
            REPLACE exal WITH tmp_exal
            REPLACE exac WITH tmp_exac
            REPLACE cecs WITH tmp_cecs
            REPLACE tceq WITH tmp_tceq
            REPLACE gyps WITH tmp_gyps
            REPLACE totc WITH tmp_totc
            REPLACE totn WITH tmp_totn
            REPLACE p2o5 WITH tmp_p2o5
            REPLACE pret WITH tmp_pret
            REPLACE fede WITH tmp_fede
            REPLACE fepe WITH tmp_fepe
            REPLACE alde WITH tmp_alde
            REPLACE alpe WITH tmp_alpe
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         SET ESCAPE OFF
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ
         
         SET CONFIRM ON
         EXIT
            
      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
  ENDIF

ENDDO
RELEASE ALL LIKE tmp*
SET BORDER TO DOUBLE
SET FORMAT TO
DEACTIVATE WINDOW f_screen
RETURN


PROCEDURE i_mphkey
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_mphkey FROM 17, 14 TO 22, 69
ACTIVATE WINDOW i_mphkey
DO WHILE .T.

   STORE 0 TO tmp_honu
   STORE SPACE(12) TO tmp_prid
   CLEAR

   * Enter HORIZON minimum values primary key values
   DO WHILE .T.
      @ 01, 04 SAY "63  Representative profile_ID" 
      @ 01, 37 GET tmp_prid  PICTURE "!!XXXXXXXXXX" ;
            MESSAGE "Enter Representative profile_ID, starting with an ISO country code"
      @ 02, 04 SAY "64  Horizon number"
      @ 02, 37 GET tmp_honu PICTURE "@Z 9" ;
            MESSAGE "Enter horizon number (1-9)"
      READ
      IF READKEY() = 15 .OR. READKEY() = 271      && <Enter>
         EXIT
      ENDIF
   ENDDO


   * Return if one of the primary key values is 0 (zero) or ""
   IF LTRIM(TRIM(tmp_prid)) = "" .OR. tmp_honu = 0
      DEACTIVATE WINDOW i_mphkey
      RELEASE WINDOW i_mphkey
      RETURN
   ENDIF


   * Check Representative profile_ID for valid ISO country code
   USE isocode ORDER pk
   STORE SUBSTR(LTRIM(TRIM(tmp_prid)), 1, 2) TO tmp_iso
   IF .NOT. SEEK(tmp_iso)
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY " ERROR:" COLOR GR+/R
      @ 01, 01 SAY "First two characters of profile_ID are not a valid"
      @ 02, 01 SAY "ISO country code."
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check existence of Representative profile_ID
   USE profile ORDER pk
   IF .NOT. SEEK(LTRIM(TRIM(tmp_prid)))	    && Rep. profile_ID not found
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY " ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(TRIM(tmp_prid))+   ;
                        " not an existing representative profile."
      @ 02, 01
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check uniqueness of primary key
   STORE LTRIM(TRIM(tmp_prid))+LTRIM(TRIM(STR(tmp_honu))) TO tmp_pkey
   USE minhoriz ORDER pk
   IF SEEK(tmp_pkey)
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY " ERROR:" COLOR GR+/R
      @ 01, 01 SAY "Horizon number "+LTRIM(STR(tmp_honu))+ ;
                   " is not unique within minimum values"
      @ 02, 01 SAY "profile "+LTRIM(TRIM(tmp_prid))+"."
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF			&& END SUID CHECK

ENDDO

DEACTIVATE WINDOW i_mphkey
RELEASE WINDOW i_mphkey
SET BORDER TO DOUBLE
RETURN
