* Module:       INPUT510.PRG
* Version:      Beta 1.0
* Purpose:      Enter climate station data in database file climstat.dbf

* Called by:    INPUT500.PRG
* Calling:      procedure i_cskey in INPUT510.PRG

* Date:         10 June 1993
* Author:       P. Tempel
* Updates:      10 June 1993         by P. Tempel
* * * * * * * * * * * * * * *

DO WHILE .T.

   * Declaration of (temporary) climate station variables
   STORE SPACE(6) TO tmp_stid
   STORE SPACE(40) TO tmp_stna
   STORE 0 TO tmp_lati, tmp_long, tmp_alti


   * Enter a valid primary key
   DO i_cskey
   IF "" = LTRIM(TRIM(tmp_stid))        && IN CASE OF ZERO KEY VALUE
      EXIT                              && RETURN TO CALLING PROGRAM
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input510
      READ

      * Process ESC
      IF READKEY() = 12               && ESC:
         STORE .N. TO tmp_answ        && RETURN TO CALLING PROGRAM
         EXIT                         && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE climstat ORDER pk
            APPEND BLANK
            REPLACE stid WITH tmp_stid
            REPLACE stna WITH tmp_stna
            REPLACE lati WITH tmp_lati
            REPLACE long WITH tmp_long
            REPLACE alti WITH tmp_alti
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ
         
         SET CONFIRM ON
         SET ESCAPE ON
         EXIT
            
      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
  ENDIF

ENDDO
RELEASE ALL LIKE tmp*
SET BORDER TO DOUBLE
SET FORMAT TO
DEACTIVATE WINDOW f_screen
RETURN




PROCEDURE i_cskey
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_cskey FROM 17, 15 TO 21, 68
ACTIVATE WINDOW i_cskey
DO WHILE .T.

   STORE SPACE(6) TO tmp_stid
   CLEAR

   * Enter Climate station primary key value
   DO WHILE .T.
      @ 01, 07 SAY "1  Climate station_ID" 
      @ 01, 40 GET tmp_stid  FUNCTION "!"  PICTURE "AA9999" ;
            MESSAGE "Enter unique climate station_ID, starting with an ISO country code"
      READ
      IF READKEY() = 15 .OR. READKEY() = 271
         EXIT
      ENDIF
   ENDDO

   * Return if primary key value is "" (empty string)
   IF "" = LTRIM(TRIM(tmp_stid))
      DEACTIVATE WINDOW i_cskey
      RELEASE WINDOW i_cskey
      RETURN
   ENDIF

   * Check climate station_ID for valid ISO country code
   USE isocode ORDER pk
   IF .NOT. SEEK(SUBSTR(tmp_stid, 1, 2))
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 08 SAY "First two characters of climate station_ID"
      @ 01, 01 SAY "are not a valid ISO country code"
      WAIT " Press any key to continue..."
      LOOP
   ENDIF

   USE climstat ORDER pk             && START PROFILE_ID CHECK
   IF SEEK (LTRIM(TRIM(tmp_stid)))
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(TRIM(tmp_stid))+" not a unique climate station_ID"
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PROFILE_ID CHECK

ENDDO
DEACTIVATE WINDOW i_cskey
RELEASE WINDOW i_cskey
SET BORDER TO DOUBLE
RETURN
