* Module:      INPUT520.PRG
* Version:     Beta 1.0
* Purpose:     Enter climate data source in database file climsour.dbf

* Called by:   INPUT000.PRG
* Calling:     Procedure i_cskey in INPUT520.PRG

* Date:        22 June 1993
* Author:      P. Tempel (ISRIC Wageningen)
* Updates:     22 June 1993           by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) climate data source variables
   STORE SPACE(6) TO tmp_soid
   STORE SPACE(40) TO tmp_sour


   * Enter a valid primary key
   DO i_cskey
   IF "" = LTRIM(TRIM(tmp_soid))
      EXIT
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input520
      READ

      * Process ESC
      IF READKEY() = 12                 && ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE climsour ORDER pk
            APPEND BLANK
            REPLACE SOID WITH tmp_soid
            REPLACE SOUR WITH tmp_sour
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLOSE DATABASES
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
CLOSE DATABASES
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_cskey
*****************
SET BORDER TO SINGLE
DEFINE WINDOW i_cskey FROM 17, 27 TO 21, 75
ACTIVATE WINDOW i_cskey
DO WHILE .T.

   STORE SPACE(6) TO tmp_soid
   CLEAR
   @ 01, 05 SAY "25  Climate data source_ID"
   @ 01, 34 GET tmp_soid  FUNCTION "!"  PICTURE "AA9999" ;
     MESSAGE "Enter climate data source_ID, starting with an ISO country code"
   READ

   IF "" = LTRIM(TRIM(tmp_soid))
      DEACTIVATE WINDOW i_cskey
      RELEASE WINDOW i_cskey
      RETURN
   ENDIF


   * Check Climate data source_ID for valid ISO country code
   USE isocode ORDER pk
   IF .NOT. SEEK(SUBSTR(tmp_soid, 1, 2))
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 08 SAY "  First two characters of climate data"
      @ 01, 01 SAY "source_ID are not a valid ISO country code."
      USE
      WAIT " Press any key to continue..."
      LOOP
   ENDIF


   USE climsour ORDER pk             && START PRIMARY KEY CHECK
   STORE LTRIM(TRIM(tmp_soid)) TO cs_pk
   IF SEEK (cs_pk)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 10 SAY LTRIM(TRIM(tmp_soid))+" is not a unique climate data"
      @ 01, 01 SAY "source_ID."
      USE
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PRIMARY KEY CHECK

ENDDO
CLOSE DATABASES
DEACTIVATE WINDOW i_cskey
RELEASE WINDOW i_cskey
SET BORDER TO DOUBLE
RETURN
