* Module:      INPUT530.PRG
* Version:     Beta 1.0
* Purpose:     Enter climate data in database file climdat.dbf

* Called by:   INPUT000.PRG
* Calling:     Procedure i_cdkey in INPUT530.PRG

* Date:        20 June 1993
* Author:      P. Tempel (ISRIC Wageningen)
* Updates:     22 April 1993           by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) climate data variables
   STORE 0 TO tmp_ftyr, tmp_ltyr, tmp_nyrs, tmp_annu
   STORE 0 TO tmp_janu, tmp_febr, tmp_marc, tmp_apri, tmp_may, tmp_june,  ;
              tmp_july, tmp_augu, tmp_sept, tmp_octo, tmp_nove, tmp_dece
   STORE SPACE(4) TO tmp_kind
   STORE SPACE(6) TO tmp_stid, tmp_soid

   STORE "RAIN, RDAY, RMAX, RR75, TEMP, TMIN, TMAX, RADI, SUNH, CLOU, VAPP, ;
          HUMI, HMIN, HMAX, WIND, WDAY, WNIG, WDIR, WRIS, EPAN, ECOL, EPIC, ;
          PETP, PETH, PETT" TO tmp_cclist


   * Enter a valid primary key
   DO i_cdkey
   IF "" = LTRIM(TRIM(tmp_stid)) .OR. "" = LTRIM(TRIM(tmp_kind))
      EXIT                                && RETURN TO CALLING PROGRAM
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   CLOSE DATABASES
   USE climsour ORDER pk


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input530
      READ

      * Process ESC
      IF READKEY() = 12                 && ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE climdat ORDER pk
            APPEND BLANK
            REPLACE STID WITH tmp_stid
            REPLACE KIND WITH tmp_kind
            REPLACE SOID WITH tmp_soid
            REPLACE FTYR WITH tmp_ftyr
            REPLACE LTYR WITH tmp_ltyr
            REPLACE NYRS WITH tmp_nyrs
            REPLACE JANU WITH tmp_janu
            REPLACE FEBR WITH tmp_febr
            REPLACE MARC WITH tmp_marc
            REPLACE APRI WITH tmp_apri
            REPLACE MAY  WITH tmp_may
            REPLACE JUNE WITH tmp_june
            REPLACE JULY WITH tmp_july
            REPLACE AUGU WITH tmp_augu
            REPLACE SEPT WITH tmp_sept
            REPLACE OCTO WITH tmp_octo
            REPLACE NOVE WITH tmp_nove
            REPLACE DECE WITH tmp_dece
            REPLACE ANNU WITH tmp_dece
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLOSE DATABASES
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
CLOSE DATABASES
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_cdkey
*****************
SET BORDER TO SINGLE
DEFINE WINDOW i_cdkey FROM 16, 27 TO 21, 72
ACTIVATE WINDOW i_cdkey
DO WHILE .T.

   STORE SPACE(6) TO tmp_stid
   STORE SPACE(4) TO tmp_kind
   CLEAR
   @ 01, 07 SAY "6  Climate station_ID"
   @ 01, 31 GET tmp_stid  FUNCTION "!"  PICTURE "AA9999" ;
     MESSAGE "Enter climate station_ID, starting with an ISO country code"
   @ 02, 07 SAY "7  Kind of data "
   @ 02, 33 GET tmp_kind   FUNCTION "!"   PICTURE "AAAA"  ;
     VALID tmp_kind $ tmp_cclist                 ;
     ERROR tmp_kind+" is not a valid climate characteristic" ;
     MESSAGE "Enter a climate characteristic relevant to SOTER"
   READ

   IF "" = LTRIM(TRIM(tmp_stid)) .OR. "" = LTRIM(TRIM(tmp_kind))
      DEACTIVATE WINDOW i_cdkey
      RELEASE WINDOW i_cdkey
      RETURN
   ENDIF


   * Check Climate station_ID for valid ISO country code
   USE isocode ORDER pk
   IF .NOT. SEEK(SUBSTR(tmp_stid, 1, 2))
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY "First two characters of climate station_ID"
      @ 02, 01 SAY "are not a valid ISO country code"
      USE
      WAIT " Press any key to continue..."
      LOOP
   ENDIF


   * Check existence of climate station against database file climstat.dbf
   USE climstat ORDER pk
   IF .NOT. SEEK(LTRIM(TRIM(tmp_stid)))
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(TRIM(tmp_stid))+" is not an existing climate station;"
      @ 02, 01 SAY "enter first (Climate menu, option A)."
      USE
      WAIT " Press any key to continue..."
      LOOP
   ENDIF


   USE climdat ORDER pk             && START PRIMARY KEY CHECK
   STORE LTRIM(TRIM(tmp_stid))+LTRIM(TRIM(tmp_kind)) TO cd_pk
   IF SEEK (cd_pk)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 14 SAY "Station_ID "+LTRIM(TRIM(tmp_stid))+" and climate"
      @ 01, 01 SAY "characteristic "+tmp_kind+" do not yield a unique"
      @ 02, 01 SAY "primary key for the climate database file"
      USE
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PRIMARY KEY CHECK

ENDDO
CLOSE DATABASES
DEACTIVATE WINDOW i_cdkey
RELEASE WINDOW i_cdkey
SET BORDER TO DOUBLE
RETURN
