* Module:      INPUT610.PRG
* Version:     Beta 1.0
* Purpose:     Enter laboratory ID/name in database file labname.dbf

* Called by:   INPUT600.PRG
* Calling:     Procedure i_lnkey in INPUT610.PRG

* Date:        22 June 1993
* Author:      P. Tempel (ISRIC Wageningen)
* Updates:     22 June 1993           by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) laboratory variables
   STORE SPACE(5) TO tmp_labo
   STORE SPACE(40) TO tmp_lnam


   * Enter a valid primary key
   DO i_lnkey
   IF "" = LTRIM(TRIM(tmp_labo))
      EXIT
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input610
      READ

      * Process ESC
      IF READKEY() = 12                 && ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE labname ORDER pk
            APPEND BLANK
            REPLACE LABO WITH tmp_labo
            REPLACE LNAM WITH tmp_lnam
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
CLOSE DATABASES
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_lnkey
*****************
SET BORDER TO SINGLE
DEFINE WINDOW i_lnkey FROM 08, 22 TO 12, 70
ACTIVATE WINDOW i_lnkey
DO WHILE .T.

   STORE SPACE(5) TO tmp_labo
   CLEAR
   @ 01, 12 SAY "1  Laboratory_ID"
   @ 01, 30 GET tmp_labo  FUNCTION "!"  PICTURE "AA999" ;
     MESSAGE "Enter laboratory_ID, starting with an ISO country code"
   READ

   IF "" = LTRIM(TRIM(tmp_labo))
      DEACTIVATE WINDOW i_lnkey
      RELEASE WINDOW i_lnkey
      RETURN
   ENDIF

   * Check Laboratory_ID for valid ISO country code
   USE isocode ORDER pk
   IF .NOT. SEEK(SUBSTR(tmp_labo, 1, 2))
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 09 SAY "First two characters of laboratory_ID"
      @ 01, 01 SAY "are not a valid ISO country code."
      WAIT " Press any key to continue..."
      LOOP
   ENDIF

   USE labname ORDER pk             && START PRIMARY KEY CHECK
   STORE LTRIM(TRIM(tmp_labo)) TO ln_pk
   IF SEEK (ln_pk)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY ln_pk+" is not a unique laboratory_ID."
      USE
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PRIMARY KEY CHECK

ENDDO
CLOSE DATABASES
DEACTIVATE WINDOW i_lnkey
RELEASE WINDOW i_lnkey
SET BORDER TO DOUBLE
RETURN
