* Module:      INPUT620.PRG
* Version:     Beta 1.0
* Purpose:     Enter laboratory method in database file labmeth.dbf

* Called by:   INPUT600.PRG
* Calling:     Procedure i_lmkey in INPUT620.PRG

* Date:        22 June 1993
* Author:      P. Tempel (ISRIC Wageningen)
* Updates:     22 June 1993           by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) laboratory method variables
   STORE SPACE(12) TO tmp_amid
   STORE SPACE(40) TO tmp_amet


   * Enter a valid primary key
   DO i_lmkey
   IF "" = LTRIM(TRIM(tmp_amid))
      EXIT
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input620
      READ

      * Process ESC
      IF READKEY() = 12                 && ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE anameth ORDER pk
            APPEND BLANK
            REPLACE AMID WITH tmp_amid
            REPLACE AMET WITH tmp_amet
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
CLOSE DATABASES
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_lmkey
*****************
SET BORDER TO SINGLE
DEFINE WINDOW i_lmkey FROM 08, 22 TO 12, 70
ACTIVATE WINDOW i_lmkey
DO WHILE .T.

   STORE SPACE(12) TO tmp_amid
   CLEAR
   @ 01, 04 SAY "7  Method of analysis_ID"
   @ 01, 30 GET tmp_amid  PICTURE "XXXXXXXXXXXX" ;
     MESSAGE "Enter method of analysis_ID"
   READ

   IF "" = LTRIM(TRIM(tmp_amid))
      DEACTIVATE WINDOW i_lmkey
      RELEASE WINDOW i_lmkey
      RETURN
   ENDIF


   USE anameth ORDER pk             && START PRIMARY KEY CHECK
   STORE LTRIM(TRIM(tmp_amid)) TO lm_pk
   IF SEEK (lm_pk)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY lm_pk+" not a unique analysis method_ID."
      USE
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PRIMARY KEY CHECK

ENDDO
CLOSE DATABASES
DEACTIVATE WINDOW i_lmkey
RELEASE WINDOW i_lmkey
SET BORDER TO DOUBLE
RETURN
