* Module:       INPUT630.PRG
* Version:      Beta 1.0
* Purpose:      Enter laboratory method data in database file labmeth.dbf

* Called by:    INPUT600.PRG
* Calling:      procedure i_lmkey in INPUT630.PRG

* Date:         24 June 1993
* Author:       P. Tempel
* Updates:      24 June 1993         by P. Tempel
* * * * * * * * * * * * * * *

DO WHILE .T.

   * Declaration of (temporary) land use variables
   STORE 0 TO tmp_attr
   STORE SPACE(5) TO tmp_labo
   STORE SPACE(6) TO tmp_date
   STORE SPACE(12) TO tmp_amid


   * Enter a valid primary key
   DO i_lmkey
   DO CASE
      CASE tmp_attr = 0 
         EXIT
      CASE LTRIM(TRIM(tmp_date)) = ""   
         EXIT
      CASE LTRIM(TRIM(tmp_labo)) = ""
         EXIT
   ENDCASE


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   * Open database file with descriptions of analytical methods
   CLOSE DATABASES
   USE anameth ORDER pk


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input630
      READ

      * Process ESC
      IF READKEY() = 12               && ESC:
         STORE .N. TO tmp_answ        && RETURN TO CALLING PROGRAM
         EXIT                         && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE labmeth ORDER pk
            APPEND BLANK
            REPLACE LABO WITH tmp_labo
            REPLACE DATE WITH tmp_date
            REPLACE ATTR WITH tmp_attr
            REPLACE AMID WITH tmp_amid
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ
         
         SET CONFIRM ON
         SET ESCAPE ON
         EXIT
            
      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
  ENDIF

ENDDO
RELEASE ALL LIKE tmp*
SET BORDER TO DOUBLE
SET FORMAT TO
DEACTIVATE WINDOW f_screen
RETURN




PROCEDURE i_lmkey
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_lmkey FROM 15, 25 TO 21, 73
ACTIVATE WINDOW i_lmkey
DO WHILE .T.

   STORE SPACE(5) TO tmp_labo
   STORE SPACE(6) TO tmp_date
   STORE 0 TO tmp_attr
   CLEAR

   * Enter Laboratory method primary key values
   DO WHILE .T.

      ON KEY LABEL F1 DO helpattr

      @ 01, 07 SAY "3  Laboratory_ID" 
      @ 01, 35 GET tmp_labo  FUNCTION "!"  PICTURE "AA999" ;
            MESSAGE "Enter laboratory_ID, starting with an ISO country code"
      @ 02, 07 SAY "4  Date of introduction"
      @ 02, 33 GET tmp_date  PICTURE "@R 99/9999"  ;
            MESSAGE "Enter date of introduction of analysis method, in MM/YYYY format"
      @ 03, 07 SAY "5  Attribute"
      @ 03, 37 GET tmp_attr   FUNCTION "B"  PICTURE "999" ;
            MESSAGE "Enter attribute number (F1 for help)"
      READ

      IF READKEY() = 15 .OR. READKEY() = 271   && Invoer voorbij eind: <CR>
         ON KEY LABEL F1
         EXIT
      ENDIF

   ENDDO


   * Return if one of the primary key values is 0 (zero)
   DO CASE
      CASE tmp_attr = 0 
         DEACTIVATE WINDOW i_lmkey
         RELEASE WINDOW i_lmkey
         RETURN
      CASE LTRIM(TRIM(tmp_date)) = ""
         DEACTIVATE WINDOW i_lmkey
         RELEASE WINDOW i_lmky
         RETURN
      CASE LTRIM(TRIM(tmp_labo)) = ""
         DEACTIVATE WINDOW i_lmkey
         RELEASE WINDOW i_lmkey
         RETURN
   ENDCASE


   * Check validity of observation date
   tmp_month = VAL(SUBSTR(tmp_date, 1, 2))
   IF tmp_month < 1 .OR. tmp_month > 12
      CLEAR
      IF "" = LTRIM(TRIM(SUBSTR(tmp_date, 1, 2)))
         tmp_date = "000000"
      ENDIF
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY SUBSTR(tmp_date, 1, 2)+   ;
                " is not a valid month. Valid months are all"
      @ 02, 01 SAY "integers in the range from 1 to 12"
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ENDIF

   tmp_year = VAL(SUBSTR(tmp_date, 3, 4))
   IF tmp_year < 1950 .OR. tmp_year > YEAR(DATE())
      IF "" = LTRIM(TRIM(SUBSTR(tmp_date, 3, 4)))
         tmp_date = "000000"
      ENDIF
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY SUBSTR(tmp_date, 3, 4)+;
                 " is not a valid year. Valid years are all"
      @ 02, 01 SAY "integers from 1950 to "+LTRIM(STR(YEAR(DATE())))
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ENDIF


   * Check Laboratory_ID for valid ISO country code
   USE isocode ORDER pk
   IF .NOT. SEEK(SUBSTR(tmp_labo, 1, 2))
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY "First two characters of laboratory_ID are not"
      @ 02, 01 SAY "a valid ISO country code."
      @ 03, 01 SAY ""
      USE
      WAIT " Press any key to continue..."
      LOOP
   ENDIF


   * Check existence of laboratory_ID (in database file labname.dbf)
   USE labname ORDER pk
   IF .NOT. SEEK(LTRIM(TRIM(tmp_labo)))   && LABORATORY_ID NOT FOUND
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(TRIM(tmp_labo))+" not an existing laboratory; enter first"
      @ 02, 01 SAY "(Laboratory menu, option A)."
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check validity of attribute number
   IF tmp_attr < 77 .OR. tmp_attr > 110
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY LTRIM(TRIM(STR(tmp_attr)))+" is not a valid attribute number."
      @ 02, 01 SAY "Valid attribute numbers are all integers from"
      @ 03, 01 SAY "77 to 110."
      WAIT " Press any key to continue..."
      LOOP
   ENDIF

   * Check values for primary key of database file labmeth.dbf
   STORE LTRIM(TRIM(tmp_labo))+LTRIM(TRIM(tmp_date))+  ;
                              LTRIM(TRIM(STR(tmp_attr))) TO lm_pk
   USE labmeth ORDER pk
   IF SEEK(lm_pk)
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 13 SAY "Laboratory_ID "+LTRIM(TRIM(tmp_labo))+", introduction"
      @ 01, 01 SAY "date "+SUBSTR(tmp_date, 1, 2)+"/"+;
                  SUBSTR(tmp_date, 3, 4)+" and attribute number "+ ;
                                        LTRIM(TRIM(STR(tmp_attr)))+" do not"
      @ 02, 01 SAY "yield a unique primary key for the laboratory"
      @ 03, 01 SAY "method database file."
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF

   EXIT   && Leave DO WHILE loop after checking key vlues

ENDDO
DEACTIVATE WINDOW i_lmkey
RELEASE WINDOW i_lmkey
SET BORDER TO DOUBLE
RETURN




PROCEDURE helpattr
******************
ACTIVATE WINDOW f_screen
CLEAR
@ 0, 0
TEXT
   77  Very coarse sand                 94  Exchangeable Magnesium
   78  Coarse sand                      95  Exchangeable Sodium
   79  Medium sand                      96  Exchangeable Potassium
   80  Fine sand                        97  Exchangeable Aluminium
   81  Very fine sand                   98  Exchangebla acidity
   82  Total sand                       99  CEC soil
   83  Silt                            100  Total carbonate equivalent
   84  Clay                            101  Gypsum
   85  Particle size class             102  Total carbon
   86  Bulk density                    103  Total nitrogen
   87  Moisture content at             104  P2O5
       various tensions                105  Phosphate retention
   88  Hydraulic conductivity          106  Fe dithionite
   89  Infiltration rate               107  Al dithionite
   90  pH H2O                          108  Fe pyrophosphate
   91  pH KCl                          109  Al pyrophosphate
   92  Electrical conductivity         110  Clay Mineralogy
   93  Exchangeable Calcium

ENDTEXT
WAIT "   Press any key to continue..."
DEACTIVATE WINDOW f_screen
RETURN
