* Module:      INPUT710.PRG
* Version:     Beta 1.0
* Purpose:     Enter source map data in database file sourcmap.dbf

* Called by:   INPUT700.PRG
* Calling:     Procedure i_smkey in INPUT710.PRG

* Date:        22 June 1993
* Author:      P. Tempel (ISRIC Wageningen)
* Updates:     22 June 1993           by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) laboratory variables
   STORE 0 TO tmp_year, tmp_mlat, tmp_mlon, tmp_xlat, tmp_xlon
   STORE SPACE(1)  TO tmp_type
   STORE SPACE(5)  TO tmp_mapi
   STORE SPACE(8)  TO tmp_scal
   STORE SPACE(40) TO tmp_titl


   * Enter a valid primary key
   DO i_smkey
   IF "" = LTRIM(TRIM(tmp_mapi))
      EXIT
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input710
      READ

      * Process ESC
      IF READKEY() = 12                 && ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE sourcmap ORDER pk
            APPEND BLANK
            REPLACE MAPI WITH tmp_mapi
            REPLACE TITL WITH tmp_titl
            REPLACE YEAR WITH tmp_year
            REPLACE SCAL WITH VAL(tmp_scal)
            REPLACE MLAT WITH tmp_mlat
            REPLACE MLON WITH tmp_mlon
            REPLACE XLAT WITH tmp_xlat
            REPLACE XLON WITH tmp_xlon
            REPLACE TYPE WITH tmp_type
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
CLOSE DATABASES
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_smkey
*****************
SET BORDER TO SINGLE
DEFINE WINDOW i_smkey FROM 09, 22 TO 13, 70
ACTIVATE WINDOW i_smkey
DO WHILE .T.

   STORE SPACE(12) TO tmp_mapi
   CLEAR
   @ 01, 08 SAY "1  Source map_ID"
   @ 01, 26 GET tmp_mapi  PICTURE "XXXXXXXXXXXX" ;
     MESSAGE "Enter new source map_ID (max. 12 characters)"
   READ


   IF "" = LTRIM(TRIM(tmp_mapi))
      DEACTIVATE WINDOW i_smkey
      RELEASE WINDOW i_smkey
      RETURN
   ENDIF


   USE sourcmap ORDER pk             && START PRIMARY KEY CHECK
   STORE LTRIM(TRIM(tmp_mapi)) TO sm_pk
   IF SEEK (sm_pk)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY sm_pk+" is not a unique source map_ID."
      USE
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PRIMARY KEY CHECK

ENDDO
CLOSE DATABASES
DEACTIVATE WINDOW i_smkey
RELEASE WINDOW i_smkey
SET BORDER TO DOUBLE
RETURN
