* Module:      INPUT720.PRG
* Version:     Beta 1.0
* Purpose:     Enter Soil profile database data in database file profildb.dbf

* Called by:   INPUT700.PRG
* Calling:     Procedure i_pdkey in INPUT520.PRG

* Date:        22 June 1993
* Author:      P. Tempel (ISRIC Wageningen)
* Updates:     22 June 1993           by P. Tempel
* * * * * * * * * * * * * * * 

DO WHILE .T.

   * Declaration of (temporary) climate data source variables
   STORE SPACE(5) TO tmp_pdid
   STORE SPACE(40) TO tmp_down


   * Enter a valid primary key
   DO i_pdkey
   IF "" = LTRIM(TRIM(tmp_pdid))
      EXIT
   ENDIF


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input720
      READ

      * Process ESC
      IF READKEY() = 12                 && ESC:
         STORE .N. TO tmp_answ          && RETURN TO CALLING PROGRAM 
         EXIT                           && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE profildb ORDER pk
            APPEND BLANK
            REPLACE PDID WITH tmp_pdid
            REPLACE DOWN WITH tmp_down
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLOSE DATABASES
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ

         SET CONFIRM ON
         SET ESCAPE ON
         EXIT

      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
   ENDIF        

ENDDO
CLOSE DATABASES
RELEASE ALL LIKE tmp*
SET FORMAT TO
SET BORDER TO DOUBLE
DEACTIVATE WINDOW f_screen
RETURN



PROCEDURE i_pdkey
*****************
SET BORDER TO SINGLE
DEFINE WINDOW i_pdkey FROM 09, 22 TO 13, 70
ACTIVATE WINDOW i_pdkey
DO WHILE .T.

   STORE SPACE(5) TO tmp_pdid
   CLEAR
   @ 01, 05 SAY "1  Soil profile database_ID"
   @ 01, 34 GET tmp_pdid  FUNCTION "!"  PICTURE "AA999" ;
     MESSAGE "Enter soil profile database_ID, starting with an ISO country code"
   READ

   IF "" = LTRIM(TRIM(tmp_pdid))
      DEACTIVATE WINDOW i_pdkey
      RELEASE WINDOW i_pdkey
      RETURN
   ENDIF


   * Check Soil profile database_ID for valid ISO country code
   USE isocode ORDER pk
   IF .NOT. SEEK(SUBSTR(tmp_pdid, 1, 2))
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 08 SAY "  First two characters of soil profile"
      @ 01, 01 SAY "database_ID are not a valid ISO country code"
      USE
      WAIT " Press any key to continue..."
      LOOP
   ENDIF


   USE profildb ORDER pk             && START PRIMARY KEY CHECK
   STORE LTRIM(TRIM(tmp_pdid)) TO pd_pk
   IF SEEK (pd_pk)
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 00, 10 SAY pd_pk+" is not a unique soil profile"
      @ 01, 01 SAY "database_ID."
      USE
      WAIT " Press any key to continue..."
   ELSE
      USE
      EXIT
   ENDIF                      && END PRIMARY KEY CHECK

ENDDO
CLOSE DATABASES
DEACTIVATE WINDOW i_pdkey
RELEASE WINDOW i_pdkey
SET BORDER TO DOUBLE
RETURN
