* Module:       INPUT730.PRG
* Version:      Beta 1.0
* Purpose:      Enter laboratory method data in database file labmeth.dbf

* Called by:    INPUT700.PRG
* Calling:      procedure i_lmkey in INPUT730.PRG

* Date:         24 June 1993
* Author:       P. Tempel
* Updates:      24 June 1993         by P. Tempel
* * * * * * * * * * * * * * *

DO WHILE .T.

   * Declaration of (temporary) land use variables
   STORE 0 TO tmp_attr
   STORE SPACE(5) TO tmp_labo
   STORE SPACE(6) TO tmp_date
   STORE SPACE(12) TO tmp_amid


   * Enter a valid primary key
   DO i_lmkey
   DO CASE
      CASE tmp_attr = 0 
         EXIT
      CASE LTRIM(TRIM(tmp_date)) = ""   
         EXIT
      CASE LTRIM(TRIM(tmp_labo)) = ""
         EXIT
   ENDCASE


   * Activate semi-full screen window
   ACTIVATE WINDOW f_screen


   DO WHILE .T.

      SET BORDER TO SINGLE
      STORE .Y. TO tmp_answ
      SET FORMAT TO input730
      READ

      * Process ESC
      IF READKEY() = 12               && ESC:
         STORE .N. TO tmp_answ        && RETURN TO CALLING PROGRAM
         EXIT                         && WITHOUT SAVE
      ENDIF

      * Process input form
      IF READKEY() = 15 .OR. READKEY() = 271     && <ENTER>
         SET FORMAT TO
         CLEAR GETS
         SET CONFIRM OFF
         SET ESCAPE OFF
         @ 20, 01 CLEAR TO 20, 75
         @ 20, 01 SAY "Store to database [Y/N]?  :" GET tmp_answ PICTURE "Y"
         READ
         IF tmp_answ
            @ 20, 40 SAY "Storing data....."
            USE labmeth ORDER pk
            APPEND BLANK
            REPLACE LABO WITH tmp_labo
            REPLACE DATE WITH tmp_date
            REPLACE ATTR WITH tmp_attr
            REPLACE AMID WITH tmp_amid
            USE
         ENDIF
         @ 20, 01 CLEAR TO 20, 75
         CLEAR GETS
         STORE .Y. TO tmp_answ
         @ 20, 01 SAY "Insert another record [Y/N]? : " GET tmp_answ PICTURE "Y"
         READ
         
         SET CONFIRM ON
         SET ESCAPE ON
         EXIT
            
      ENDIF

   ENDDO

   IF tmp_answ
      DEACTIVATE WINDOW f_screen   && INSERT ANOTHER RECORD
      LOOP                         && START AT BEGINNING OF DO WHILE LOOP
   ELSE
      EXIT                         && RETURN TO CALLING PROGRAM
  ENDIF

ENDDO
RELEASE ALL LIKE tmp*
SET BORDER TO DOUBLE
SET FORMAT TO
DEACTIVATE WINDOW f_screen
RETURN




PROCEDURE i_lmkey
****************
SET BORDER TO SINGLE
DEFINE WINDOW i_lmkey FROM 15, 22 TO 21, 70
ACTIVATE WINDOW i_lmkey
DO WHILE .T.

   STORE SPACE(5) TO tmp_labo
   STORE SPACE(6) TO tmp_date
   STORE SPACE(12) TO tmp_amid
   CLEAR

   * Enter Laboratory method primary key values
   DO WHILE .T.
      @ 01, 07 SAY "3  Laboratory_ID" 
      @ 01, 35 GET tmp_labo  FUNCTION "!"  PICTURE "AA999" ;
            MESSAGE "Enter laboratory_ID, starting with an ISO country code"
      @ 02, 07 SAY "4  Date of observation"
      @ 02, 32 GET tmp_date  PICTURE "@R 99/9999"  ;
            MESSAGE "Enter date of introduction, in MM/YYYY format"
      @ 03, 07 SAY "5  Method of analysis_ID"
      @ 03, 36 GET tmp_amid   PICTURE "XXXXXXXXXXXX" ;
            MESSAGE "Enter method of analysis_ID (max. 12 characters)"
      READ

      IF READKEY() = 15 .OR. READKEY() = 271
         EXIT
      ENDIF

   ENDDO


   * Return if one of the primary key values is 0 (zero)
   DO CASE
      CASE tmp_attr = 0 
         DEACTIVATE WINDOW i_lmkey
         RELEASE WINDOW i_lmkey
         RETURN
      CASE LTRIM(TRIM(tmp_date)) = ""
         DEACTIVATE WINDOW i_lmkey
         RELEASE WINDOW i_lmky
         RETURN
      CASE LTRIM(TRIM(tmp_luse)) = ""
         DEACTIVATE WINDOW i_lmkey
         RELEASE WINDOW i_lmkey
         RETURN
   ENDCASE


   * Check for valid ISO country code
   USE terrain ORDER pk
   IF .NOT. SEEK(tmp_suid)    && SUID NOT FOUND
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 02, 01 SAY LTRIM(STR(tmp_suid))+" not an existing SOTER unit"
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check validity of observation date
   tmp_month = VAL(SUBSTR(tmp_date, 1, 2))
   IF tmp_month < 1 .OR. tmp_month > 12
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY SUBSTR(tmp_date, 1, 2)+   ;
                " is not a valid month. Valid months are all"
      @ 02, 01 SAY "integers in the range from 1 to 12"
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ENDIF

   tmp_year = VAL(SUBSTR(tmp_date, 3, 4))
   IF tmp_year < 1950 .OR. tmp_year > YEAR(DATE())
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY SUBSTR(tmp_date, 3, 4)+;
                 " is not a valid year. Valid years are all"
      @ 02, 01 SAY "integers from 1950 to "+LTRIM(STR(YEAR(DATE())))
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ENDIF


   * Check exixtence of landuse code
   USE lu_code ORDER pk
   IF .NOT. SEEK(LTRIM(TRIM(tmp_luse)))   && LAND USE CODE NOT FOUND
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 02, 01 SAY LTRIM(TRIM(tmp_luse))+" not a valid land use code"
      @ 03, 01 SAY ""
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF


   * Check values for primary key of database file landuse.dbf
   STORE STR(tmp_suid)+LTRIM(TRIM(tmp_date))+LTRIM(TRIM(tmp_luse)) TO lu_pk
   USE landuse ORDER pk
   IF SEEK(lu_pk)
      USE
      CLEAR
      ? beep
      @ 00, 01 SAY "ERROR:" COLOR GR+/R
      @ 01, 01 SAY "SOTER unit ID "+LTRIM(STR(tmp_suid))+           ;
                   ", observation date "+SUBSTR(tmp_date, 1, 2)+"/"+;
                   SUBSTR(tmp_date, 3, 4)
      @ 02, 01 SAY "and land use code "+LTRIM(TRIM(tmp_luse))+;
                      " do not yield a unique"
      @ 03, 01 SAY "primary key for the land use database file"
      WAIT " Press any key to continue..."
      LOOP
   ELSE
      USE
   ENDIF

   EXIT   && Leave DO WHILE loop after checking key vlues

ENDDO
DEACTIVATE WINDOW i_lmkey
RELEASE WINDOW i_lmkey
SET BORDER TO DOUBLE
RETURN
