SET TALK OFF
SET ECHO OFF
SET BELL OFF

* Clear environment
CLEAR
CLEAR ALL

SET DIRECTORY TO C:\SOTER4   && !! Change if necessary !!

* Restore default settings from memory file SOTER.MEM
RESTORE FROM soter
RESTORE FROM sotmem ADDITIVE


* Global color settings
IF ISCOLOR()
   c_normal = "W/B, B/W, B"   
   c_pop    = "W/B, B/W, B"
   c_box    = "W/B"
ELSE 
   c_box = "W/N"
   SET COLOR TO
ENDIF
SET COLOR OF BOX TO &c_box


* Define warning signal
STORE CHR(7) TO beep


* Set up environment
SET BORDER TO DOUBLE
SET CARRY OFF
SET CONFIRM ON
SET DATE TO ymd
SET DBTRAP ON
*SET DEFAULT TO &d_disk
SET DESIGN ON                  && OFF for end version
SET DEVELOPMENT ON
*SET DIRECTORY TO &d_dir
SET CATALOG TO soter
SET ENCRYPTION OFF
*SET ESCAPE ON            && development mode; production mode is OFF
SET EXACT ON
*SET FULLPATH ON
SET HELP OFF
SET HISTORY OFF
SET HOURS TO 24
*SET MARGIN TO 8
SET PROCEDURE TO soterprc
SET SAFETY OFF
SET SCOREBOARD ON
SET STATUS OFF
SET TYPEAHEAD TO 20
SET UNIQUE OFF


*Initiate function (F#-)keys
SET FUNCTION F2  TO SPACE(0)
SET FUNCTION F3  TO SPACE(0)
SET FUNCTION F4  TO SPACE(0)
SET FUNCTION F5  TO SPACE(0)
SET FUNCTION F6  TO SPACE(0)
SET FUNCTION F7  TO SPACE(0)
SET FUNCTION F8  TO SPACE(0)
SET FUNCTION F9  TO SPACE(0)
SET FUNCTION F10 TO SPACE(0)


ON ERROR DO err_proc WITH MESSAGE(), PROGRAM(), ERROR()


* Introductory screens
TEXT


                       
                                            
                                            
                         
                                             
                                             
                       


                   World Soils and Terrain Digital database
                                Beta version 1.0


                                     ISRIC                               
              International Soil Reference and Information Centre         
                                  P.O.Box 353                             
                              6700 AJ  Wageningen                         
                                The Netherlands                           
                                                                         


ENDTEXT
@ 01, 01 TO 23, 78 DOUBLE
WAIT " Press any key to continue..."
CLEAR
TEXT

                                                                         
     Welcome to SOTER                                                  
     
                                                                      
     The aim of the SOTER project is to utilize current and emerging
     information technology to establish a World Soils and Terrain
     Digital Database, containing digitized map units and their attribute  
     data. The main function of this database is to provide the necessary
     data for improved mapping and monitoring of changes of world soil and
     terrain resources. It will be base on a computerized information
     system composed of a database, a Geographical Information System, and
     a database management system, that will be capable of delivering
     accurate, useful and timely information to a wide tange of scientists,
     planners, decision-makers, and policy-makers.
                                                                         
                                  27 February 1993                          
                                                                         


ENDTEXT
@ 01, 01 TO 23, 78 DOUBLE
WAIT " Press any key to continue..."
CLEAR


* Define main menu (mainmenu)
DEFINE POPUP mainmenu FROM 02, 18 TO 22, 62  MESSAGE ;
  "Press capital letter of menu choice, or highlight and press <Enter>"
DEFINE BAR  2 OF mainmenu PROMPT SPACE(9)+"SOTER - Beta version 1.0" SKIP
DEFINE BAR  3 OF mainmenu PROMPT SPACE(9)+"      Main menu  " SKIP
DEFINE BAR  4 OF mainmenu PROMPT REPLICATE("", 43) SKIP
DEFINE BAR  5 OF mainmenu PROMPT "   A  Enter new data"
DEFINE BAR  6 OF mainmenu PROMPT "   B  Modify/edit data"
DEFINE BAR  7 OF mainmenu PROMPT "   C  Delete data"
DEFINE BAR  9 OF mainmenu PROMPT "   D  Select/display data"
DEFINE BAR 10 OF mainmenu PROMPT "   E  View coding system"
DEFINE BAR 11 OF mainmenu PROMPT "   F  Import/export"
DEFINE BAR 13 OF mainmenu PROMPT "   G  Set up"
DEFINE BAR 14 OF mainmenu PROMPT "   H  GIS"
DEFINE BAR 15 OF mainmenu PROMPT "   R  Quit to dBASE dot prompt"
DEFINE BAR 16 OF mainmenu PROMPT REPLICATE("", 43) SKIP
DEFINE BAR 18 OF mainmenu PROMPT "   Q  Quit to DOS"
ON SELECTION POPUP mainmenu DO main


* Define warning/error message window (warning)
DEFINE WINDOW warning FROM 13,10 TO 18,70 COLOR GR+/R,GR+/R,GR+/R


* Define a full screen window 
SET BORDER TO SINGLE
DEFINE WINDOW f_screen FROM 01,00 TO 23,79
SET BORDER TO DOUBLE


* Display main menu and loop for choices
DO WHILE BAR() <> 15
   SET COLOR TO &c_pop
   SET COLOR OF BOX TO &c_box.
   CLEAR
   ACTIVATE POPUP mainmenu
ENDDO
CLEAR ALL
SET FUNCTION F2  TO
SET FUNCTION F3  TO
SET FUNCTION F4  TO 
SET FUNCTION F5  TO
SET FUNCTION F6  TO
SET FUNCTION F7  TO
SET FUNCTION F8  TO
SET FUNCTION F9  TO
SET FUNCTION F10 TO
SET HISTORY ON
SET SAFETY ON
SET STATUS ON
CLEAR
RETURN


PROCEDURE main
   DO CASE
      CASE BAR() = 5
         DO INPUT000
      CASE BAR() = 6 
         DO EDIT200
      CASE BAR() = 7
         DO S_EXIT WITH "NOT YET AVAILABLE"
      CASE BAR() = 9
         DO S_EXIT WITH "NOT YET AVAILABLE"
      CASE BAR() = 10
         DO S_EXIT WITH "NOT YET AVAILABLE"
      CASE BAR() = 11
         DO S_EXIT WITH "NOT YET AVAILABLE"
      CASE BAR() = 13
         DO S_EXIT WITH "NOT YET AVAILABLE"
      CASE BAR() = 14
         DO S_EXIT WITH "NOT YET AVAILABLE"
      CASE BAR() = 15 .OR. BAR() = 18
         RELEASE ALL
         IF BAR() = 15
            @ 24, 0 CLEAR TO 24, 79
            DO s_exit WITH "Returning to dBASE dot prompt..."
            RETURN TO MASTER
         ELSE
            @ 24, 0 CLEAR TO 24, 79
            DO s_exit WITH "Returning to operating system..."
            QUIT
         ENDIF
   ENDCASE
RETURN
